/*======================================================
Balk     : C++ ' taki TEMPLATE ' ler Ne e Yarar?
Amacmz   : Deiik Veri Tiplerine Cevap Verebilen 
             Fonksiyonlar Hazrlamak
Hazrlayan : Beycan Kahraman
======================================================*/

#include <iostream>

#define BOYUT 8

using namespace std;

/*======================================================
Fonksiyon : SIRALA
Aklama  : Aadaki fonksiyon girilen deiik 
            veri tiplerini sralayabilmektedir.
            Sralamann salanabilmesi iin girilen
            veri < ve = operatrlerini desteklemelidir.
======================================================*/

template <class Tip>
void Sirala(Tip *Dizi){ // Kkten Bye
    Tip tmp;
    for(int i=0; i<BOYUT; i++)
        for(int j=i; j<BOYUT; j++)
            if(Dizi[j] < Dizi[i]){ // eriklerini deitir
                tmp = Dizi[j];
                Dizi[j] = Dizi[i];
                Dizi[i] = tmp;
            }    
}

/*======================================================
Fonksiyon : EKRANA BAS
Aklama  : Aadaki fonksiyon girilen deiik
            veri tiplerini ekrana basar.
            Ekrana baslan veri tipi, cout yapsnn 
            << operatrn desteklemelidir.
======================================================*/

template <class tip>
void EkranaBas(tip *Dizi){
    for(int i=0; i<BOYUT; i++)
        cout << Dizi[i] << ", ";
    cout << "\n---------------------------------------\n";
}

/*======================================================
Class    : KOMPLEKS
Aklama : Aada tanmladmz kompleks tipini 
           yukardaki fonksiyonlarda kullanacaz.
======================================================*/

class Kompleks{
    int reel, sanal;
    public:
        Kompleks(int r = 0, int s = 0) : reel(r), sanal(s) {}
        bool operator<(const Kompleks &in){
            if(reel*reel + sanal*sanal < in.reel*in.reel + in.sanal*in.sanal)
                return true; // Siraladaki karlatrma iin gerekli
            return false;
        } 
        void operator=(const Kompleks &in){
            reel = in.reel;  // Siraladaki eitleme iin gerekli
            sanal = in.sanal;
        }
        friend ostream& operator<<(ostream&, const Kompleks&);
};

/*======================================================
Fonksiyon : Operatr <<
Aklama  : Aadaki fonksiyon Kompleks Tipinden Olan
            Verilerin Ekrana Nasl Baslacan Gsterir.
======================================================*/

ostream& operator<<(ostream& out, const Kompleks& in){
    out << in.reel; // Ekrana Basarken Gerekli
    if(in.sanal != 0)
        out << "+" << in.sanal << "i";
    return out;
}


int main(void){
    int      a[] = {1, 5, 7, 2, 4, 8, 0, 3};
    float    b[] = {1.2, 3.2, 4.1, 1.6, 6.2, 3.1, 5.2, 0.3};
    bool     c[] = {true, false, false, true, false, true, false, true};
    char     d[] = "TEMPLATE";
    Kompleks e[] = {Kompleks(0,1), Kompleks(0,2), Kompleks(2), Kompleks(1,1),
                    Kompleks(4,2), Kompleks(1,2), Kompleks(1), Kompleks() };
    string   f[] = {"alo", "ver", "al", "yok", "var", "evet", "no", "ev"};
    
    EkranaBas(e); //  u an iin fonksiyonlar Kompleks saylarda
    Sirala(e);    //  ilem yapyorlar ...
    EkranaBas(e);
    
    system("PAUSE");
    return 1;
}

